Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osg::ClipNode Class Reference

Node for defining the position of ClipPlanes in the scene. More...

Inheritance diagram for osg::ClipNode:

[legend]
List of all members.

## Public Types
typedef std::vector< ref_ptr< ClipPlane > > | ClipPlaneList
## Public Member Functions
| ClipNode ()
| ClipNode (const ClipNode &es, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, ClipNode)
void | createClipBox (const BoundingBox &bb, unsigned int clipPlaneNumberBase=0)
| Creates six clip planes corresponding to the given BoundingBox.
bool | addClipPlane (ClipPlane *clipplane)
| Adds the clipplane.
bool | removeClipPlane (ClipPlane *clipplane)
| Removes the clipplane.
bool | removeClipPlane (unsigned int pos)
| Remove the ClipPlane with the given index.
unsigned int | getNumClipPlanes () const
| Returns the number of ClipPlanes.
ClipPlane * | getClipPlane (unsigned int pos)
| Get ClipPlane at the given index position.
const ClipPlane * | getClipPlane (unsigned int pos) const
| Get const ClipPlane at the given index position.
void | getClipPlaneList (const ClipPlaneList &cpl)
| Set the ClipPlaneList.
ClipPlaneList & | getClipPlaneList ()
| Get the ClipPlaneList.
const ClipPlaneList & | getClipPlaneList () const
| Get the const ClipPlaneList.
void | setStateSetModes (StateSet &, StateAttribute::GLModeValue) const
| Set the GLModes for all ClipPlanes, on the StateSet.
void | setLocalStateSetModes (StateAttribute::GLModeValue=StateAttribute::ON)
| Set up the local StateSet.
virtual BoundingSphere | computeBound () const
| Compute the bounding sphere around Node's geometry or children.
## Protected Member Functions
virtual | ~ClipNode ()
## Protected Attributes
StateAttribute::GLModeValue | _value
ClipPlaneList | _planes

## Detailed Description

Node for defining the position of ClipPlanes in the scene.

## Member Typedef Documentation

typedef std::vector<ref_ptr<ClipPlane> > osg::ClipNode::ClipPlaneList

## Constructor & Destructor Documentation

osg::ClipNode::ClipNode | ( |  | ) |

osg::ClipNode::ClipNode | ( | const ClipNode & | es,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY
| ) |

virtual osg::ClipNode::~ClipNode | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

bool osg::ClipNode::addClipPlane | ( | ClipPlane * | clipplane | ) |

| Adds the clipplane. Returns true on success, and false if the plane has already been added, or if clipplane is NULL.

virtual BoundingSphere osg::ClipNode::computeBound | ( |  | ) | const`[virtual]`

| Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound(). Reimplemented from osg::Group.

void osg::ClipNode::createClipBox | ( | const BoundingBox & | bb,
|  | unsigned int | clipPlaneNumberBase = 0
| ) |

| Creates six clip planes corresponding to the given BoundingBox.

const ClipPlane* osg::ClipNode::getClipPlane | ( | unsigned int | pos | ) | const`[inline]`

| Get const ClipPlane at the given index position.

ClipPlane* osg::ClipNode::getClipPlane | ( | unsigned int | pos | ) | `[inline]`

| Get ClipPlane at the given index position.

const ClipPlaneList& osg::ClipNode::getClipPlaneList | ( |  | ) | const`[inline]`

| Get the const ClipPlaneList.

ClipPlaneList& osg::ClipNode::getClipPlaneList | ( |  | ) | `[inline]`

| Get the ClipPlaneList.

void osg::ClipNode::getClipPlaneList | ( | const ClipPlaneList & | cpl | ) | `[inline]`

| Set the ClipPlaneList.

unsigned int osg::ClipNode::getNumClipPlanes | ( |  | ) | const`[inline]`

| Returns the number of ClipPlanes.

osg::ClipNode::META_Node | ( | osg | ,
|  | ClipNode |
| ) |

bool osg::ClipNode::removeClipPlane | ( | unsigned int | pos | ) |

| Remove the ClipPlane with the given index. Returns true on success, false if pos is not a valid plane index.

bool osg::ClipNode::removeClipPlane | ( | ClipPlane * | clipplane | ) |

| Removes the clipplane. Returns true on success, false if clipplane isn't in this ClipNode.

void osg::ClipNode::setLocalStateSetModes | ( | StateAttribute::GLModeValue | = StateAttribute::ON | ) |

| Set up the local StateSet.

void osg::ClipNode::setStateSetModes | ( | StateSet & | ,
|  | StateAttribute::GLModeValue |
| ) | const

| Set the GLModes for all ClipPlanes, on the StateSet.

## Member Data Documentation

ClipPlaneList osg::ClipNode::_planes`[protected]`

StateAttribute::GLModeValue osg::ClipNode::_value`[protected]`

The documentation for this class was generated from the following file:

- ClipNode